include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext MonoPattern,ColorPattern
ext VVramFront_, RowFlags_


PagePort equ 3dfh
CharPatternSize equ VramStep*CharHeight
SpritePatternSize equ CharPatternSize*4
VramTop equ Vram

dseg
CharRam: public CharRam
    defs CharPatternSize*Char_End
Backup:
	defs VVramWidth*VVramHeight

cseg
InitVram: public InitVram
    mov ax,0009h | int 10h ; SET MODE

	mov di,CharRam+CharPatternSize*Char_Ascii
	mov si,MonoPattern+CharHeight*Char_Ascii
	mov cx,(0fh shl 8) or (Char_Logo-Char_Ascii)
	call MakePatternMono

	mov di,CharRam+CharPatternSize*Char_Logo
	mov si,MonoPattern+CharHeight*Char_Logo
	mov cx,(0bh shl 8) or (Char_Star-Char_Logo)
	call MakePatternMono

	mov di,CharRam+CharPatternSize*Char_Star
	mov si,MonoPattern+CharHeight*Char_Star
	mov cx,(0fh shl 8) or (Char_EnemyBullet-Char_Star)
	call MakePatternMono

	mov di,CharRam+CharPatternSize*Char_EnemyBullet
	mov si,MonoPattern+CharHeight*Char_EnemyBullet
	mov cx,(0eh shl 8) or (Char_Enemy-Char_EnemyBullet)
	call MakePatternMono

	mov ax,ds | mov es,ax
    mov di,CharRam+CharPatternSize*Char_Enemy
	mov si,ColorPattern
	mov cx,CharPatternSize*(Char_End-Char_Enemy)/2
	do | movsw | wloop
ret

MakePatternMono:
	mov bl,ch
    and bl,0fh
    mov bh,ch
    shr bh,1 | shr bh,1 | shr bh,1 | shr bh,1
	do
		mov ch,CharHeight
		do
			push cx
				mov al,[si] | inc si
                mov ch,4
                do
                    xor ah,ah
                    mov cl,2
                    do
                        shl ah,1 | shl ah,1 | shl ah,1 | shl ah,1
                        shl al,1
	    				if c
		    				or ah,bl
                        else
                            or ah,bh
    					endif
                        dec cl
                    while nz | wend
					mov [di],ah | inc di
					dec ch
				while nz | wend
			pop cx
			dec ch
		while nz | wend
		dec cl
	while nz | wend
ret


; void ClearScreen();
cseg
ClearScreen_:  public ClearScreen_
	push ax | push cx | push dx | push bx
		mov ax,VramSegment | mov es,ax
		xor ax,ax
        mov bx,0
		do
            mov es:[bx],ax
            inc bx | inc bx
			cmp bx,8000h
		while ne | wend

		xor ax,ax 
		mov bx,backup
		mov cx,VVramWidth*VVramHeight
		do
			mov [bx],ax
			inc bx | inc bx
		wloop
	pop bx | pop dx | pop cx | pop ax
ret


cseg
Put1:
; in
;   al: char
;   es:di: vram address
    push cx
        mov ah,CharPatternSize | mul ah
        add ax,CharRam
        mov si,ax
        mov ch,2
        do
            mov cl,4
            do
                movsw
                movsw
                add di,2000h-4
                dec cl
            while nz | wend
            add di,VramWidth-2000h*4
            dec ch
        while nz | wend
    pop cx
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
	push ax | push si | push di
	    mov di,ax
        mov ax,VramSegment | mov es,ax
		mov al,dl
        call Put1
	pop di | pop si | pop ax
	add ax,VramStep
ret


cseg
VVramToVramRow:
	mov cl,VVramWidth
	do 
		mov al,[bx]
		inc bx
		cmp al,[si]
		if ne
			mov [si],al
			push si | push di
				call Put1
			pop di | pop si
		endif
		add di,VramStep
		inc si
		dec cl
	while nz | wend
	add di,VramWidth*2-VVramWidth*VramStep
ret


; void VVramToVramAll();
cseg
VVramToVramAll_: public VVramToVramAll_
	push ax | push cx | push dx | push bx | push si | push di
        mov ax,VramSegment | mov es,ax
		mov bx,VVramFront_
		mov si,Backup
		mov di,VramTop
		mov ch, VVramHeight ; vertical count
		do
			call VVramToVramRow
			dec ch
		while nz | wend
	pop di | pop si | pop bx | pop dx | pop cx | pop ax
ret 


; void VVramToVramChanged();
dseg
pFlags:
	defw 0
flags:
	defb 0
flagBit:
	defb 0
cseg
VVramToVramChanged_: public VVramToVramChanged_
	push ax | push cx | push dx | push bx | push si | push di
		mov bx,RowFlags_
		mov byte ptr[flagBit],1
		mov al,[bx] | inc bx
		mov [flags],al
		mov [pFlags],bx

        mov ax,VramSegment | mov es,ax
		mov bx,VVramFront_
		mov si,Backup
		mov di,VramTop
		mov ch, VVramHeight ; vertical count
		do
			mov al,[flags]
			and al,[flagBit]
			if nz
				call VVramToVramRow
			else
				add bx,VVramWidth
				add si,VVramWidth
				add di,VramWidth*2
			endif

			rol [flagBit]
			if c
				push bx
					mov bx,[pFlags]
					mov al,[bx] | inc bx
					mov [flags],al
					mov [pFlags],bx
				pop bx
			endif
			dec ch
		while nz | wend
        xor ax,ax
        mov [RowFlags_],ax
        mov [RowFlags_+2],ax
	pop di | pop si | pop bx | pop dx | pop cx | pop ax
ret 
